#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include "xwio.h"

extern struct SetupDataStruct setupdata;
extern struct ConsoleStruct console;


int BootRoot (struct LinkStruct *link);
void FileSliceOut (struct LinkStruct *link, char *filename);


int Reset (struct LinkStruct *link)
/* System reset.. */
        {
	if (-1==BootRoot (link))
		{
		simple_write (console.twin, "Reset failed.\n");
		return -1;
		}
	simple_write (console.twin, "Loading kernel \n");
	FileSliceOut (link, find_file ("kernel.lkd"));
	simple_write (console.twin, "Loading network data \n");
	FileSliceOut (link, find_file (setupdata.networkfile));
	simple_write (console.twin, "Booting Network \n");
	return 0;
        }

void Worm (struct LinkStruct *link)
/* System zurcksetzen... */
        {
        if (-1==BootRoot (link))
	 	{
		simple_write (console.twin, "Reset failed.\n");
		}
	simple_write (console.twin, "Loading worm kernel \n");
	FileSliceOut (link, "worm.lkd");
        }

void WordOut (struct LinkStruct *link, int l)
        {
	int i;
	i=swint (l);
        WriteChunk (link->id, (char *)(&i), sizeof (int));
        }

void FileSliceOut (struct LinkStruct *link, char *filename)
        {
        int f;
        int n;
	char *buf;
	struct stat status;

	if (-1==stat (filename, &status))
		{
		simple_write (console.twin, "FileSliceOut: error opening file");
		simple_write (console.twin, filename);
		simple_write (console.twin, ": ");
		simple_write (console.twin, strerror (errno));
		return;
		}
	n=status.st_size;

        f=open (filename, O_RDONLY);

        WordOut (link, n);
        buf=malloc (n+2);
        read (f, buf, n);
        WriteChunk (link->id, buf, n);
        free (buf);
        close(f);
        }

int BootRoot (struct LinkStruct *link)
/* Root node reset */
        {
	int	f;
	struct stat status;
	char	*buf;
	int	n;
	char file[100];
	char *p;
	
/*
	kill (link->in_pid, SIGUSR1);
	kill (link->out_pid, SIGUSR1);
*/
        ResetLink(link->id);

	simple_write (console.twin, "Booting root node \n");
        
	p = find_file ("cstart.t");
	if (p == NULL) 
		{
		simple_write (console.twin, "BootRoot: cstart.t not found.");
		simple_write (console.twin, "check BBIN shell variable.");
		return -1;
		}

	strcpy (file, p);
	if (-1==stat (file, &status))
		{
		simple_write (console.twin, "BootRoot: error opening file");
		simple_write (console.twin, file);
		simple_write (console.twin, " : ");
		simple_write (console.twin, strerror (errno));
		return -1;
		}
	n=status.st_size;
	f=open (file, O_RDONLY);
        
	buf=malloc (n+2);

        read (f, buf, n);
        WriteChunk (link->id, buf, n);
        free (buf);
        close(f);

        simple_write (console.twin, "Loading Bootcode \n");
        FileSliceOut (link, file);
        WordOut (link, 0x80010000);
        WordOut (link, 0x8000F000);
	return 0;
        }

