#include "xwio.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

extern struct pidref *object_plist;

int open_file (char *filename, int mode)
/*
 *	create a file object...
 */

	{
	int	f;

	struct FileStruct *file;

	file=(struct FileStruct *)malloc (sizeof (struct FileStruct));
	switch (mode)
		{
		case OM_READ:
			file->fd=fopen (filename, "r");
			break;
		case OM_WRITE:
			file->fd=fopen (filename, "w");
			break;
		case OM_APPEND:
			file->fd=fopen (filename, "a");
			break;
		case OM_MODIFY:
			file->fd=fopen (filename, "r+");
			break;
		}
	if (file->fd)
		{
		file->magic=PID_MAGIC_FILE;
        	return plist_add (object_plist, file);
		}
	else	{
		free (file);
		return -1;
		}
	}

void close_file (struct FileStruct *file)
/*
 *	Destroy file object
 */
	{
	fclose (file->fd);
	free (file);
	}

void write_file (struct FileStruct *file, char *str)
/*
 *	write string into file 
 */
	{
	fputs (str, file->fd);
	}

void write_n_file (struct FileStruct *file, int n, char *str)
/*
 *	write string into file 
 */
	{
	fwrite (str, 1, n, file->fd);
	}

void read_file (struct FileStruct *file, int n, int tid, int pid)
	{
	char *buf;
	int n1;

	if (feof (file->fd))
		SendRet (tid, pid, -1);
	else
		{
		buf=malloc (n+8);
		n1=fread (buf+4, 1, n, file->fd);
		intbuf ((((n1/4)+1)<<4)|3L, buf);
       		SendRetStruct (tid, pid, buf, n1+4);
		free (buf);
		}
	}

void readch_file (struct FileStruct *file, int tid, int pid)

	{
	char c;
	if (feof (file->fd))
		SendRet (tid, pid, -1);
	else	
		SendRet (tid, pid, fgetc (file->fd));
	}

void readln_file (struct FileStruct *file, int tid, int pid)
	{
	char buf[READ_BUFFER_SIZE];
	
	if (feof (file->fd))
		SendRet (tid, pid, -1);
	else	{
		if (fgets (buf, READ_BUFFER_SIZE, file->fd))
			{
			while (buf[strlen (buf)-1]=='\n' || buf[strlen (buf)-1]=='\r')
				buf[strlen (buf)-1]='\0';
			SendRetStr (tid, pid, buf);
			}
		else
			SendRet (tid, pid, -1);
		}
	}


int file_eof (int pid)
	{
	struct FileStruct *file;

	file=(struct FileStruct *)plist_get (object_plist, pid);
	if (!file)
		return -1;
	if (file->magic!=PID_MAGIC_FILE)
		return -1;
	if (feof (file->fd))
		return 1;
	else
		return 0;
	}

int file_pos (int pid, int pos)
	{
	struct FileStruct *file;

	file=(struct FileStruct *)plist_get (object_plist, pid);
	if (!file)
		return -1;
	if (file->magic!=PID_MAGIC_FILE)
		return -1;
	if (pos!=-1)
		fseek (file->fd, pos, SEEK_SET);
	return ftell (file->fd);
	}

int file_date (char *filename)
	{
	struct stat status;
	if (-1==stat (filename, &status))
		return -1;
	else
		return status.st_mtime;
	}

int file_size (char *filename)
	{
	struct stat status;
	if (-1==stat (filename, &status))
		return -1;
	else
		return status.st_size;
	}

int file_out (char *filename, char *buf, int len)
	{
	int f;

	f=open (filename, O_CREAT | O_WRONLY);
	if (-1==f)
		return -1;
	else
		return write (f, buf, len);
	}

