/*
 *		LINKPRIM.C	
 *		Link primitives ...
 */

#include "xwio.h"
#ifdef Linux
#include <linux/b004.h>
#endif
#define	TSLEEP_A	300


char oldhead[8];
char oldblock[1024];

int ReadChunk ( int LinkId, char *Buffer, int len)

	{
	int 	i;
	int	alen=len;

	if (len & 3)
		fprintf (stderr, "ReadLink doesn't want to read %d bytes.\n",len);
	while (len)
		{
		i= ReadLink (LinkId, Buffer, len, TOUT_A);
		if (i<0 && errno!=EFAULT)
			fprintf (stderr, "ReadLink returned error.\n");
		if (i<0) i=0;
		if (i>len)
			fprintf (stderr, "ReadLink read too many bytes: %d instead of %d.\n",i,len);
		len-=i;
		Buffer+=i;
		if (len)
			{
			while (!TestRead (LinkId))
				{
				usleep (TSLEEP_A);
				}
			fprintf (stderr, "ReadChunk polling for %d bytes of %d\n", len, alen);
			}
		}
	return 1;
	}

int WriteChunk (int LinkId, char *Buffer, int len)

	{
	int i;
	int alen=len;

	while (len)
		{
		i= WriteLink (LinkId, Buffer, len, TOUT_A);
		if (i<0 && errno!=EFAULT)
			fprintf (stderr, "WriteLink returned error.\n");
		if (i<0) i=0;
		len-=i;
		Buffer+=i;
		if (len)
			{
			while (!TestWrite (LinkId))
				{
				usleep (TSLEEP_A);
				}
			fprintf (stderr, "WriteChunk polling for %d bytes of %d\n", len, alen);
			_exit (1);
			}
		}
	return 1;
	}

int ReadBlock (int LinkId, char *header, char *buffer)

	{
	int 	l;

	if (-1== ReadChunk (LinkId, header, HEADER_LEN))
		return -1;
	if (bufint (header)!= 0 || bufint16(header+4)!=0 )
		{
		fprintf (stderr, "ReadBlock received bad msg.\n");
		fprintf (stderr, "old block:\n");
		dumpmem (oldhead, 8);
		dumpmem (oldblock, 512);
		fprintf (stderr, "new header:\n");
		dumpmem (header, 8);
		}
	l=bufint16 (header+6) & 0xFFF;
	if (-1== ReadChunk (LinkId, buffer, l))
		return -1;
	memcpy (oldhead, header, 8);
	memcpy (oldblock, buffer, 512);
	return l;
	}

int WriteBlock ( int LinkId, char *header, char *buffer)

	{
	int	l;

	if (-1== WriteChunk (LinkId, header, HEADER_LEN))
		return -1;
	l=bufint16 (header+6) & 0xFFF;
	if (-1== WriteChunk (LinkId, buffer, l))
		return -1;
	return l;
	}

