#include "xwio.h"
#include <xview/notice.h>
#include <xview/defaults.h>
#ifdef USE_FILECHOOSER
#include <xview/file_chsr.h>
#endif
#include <xview/cms.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <stdlib.h>


struct list *proc_list;
struct pidref *object_plist;
struct list *trace_list;
struct ConsoleStruct console;
struct SpyStruct *spy=NULL;

int ServerTid=0;
int ServerPid=0;
char bootfile[SETUP_FILE_LEN];
Frame	dummyframe;
struct TwinStruct *dummy_twin;
int	fRunAll;

GC		gc;
XFontStruct 	*font;

Menu	menu1, menu2, menu3, twin_menu;

struct SetupDataStruct setupdata=
	{
	"generic.boo",
	"shell.lkd",
	"bbk-s4 b0 l0",
	0, 0 };
int	noreset=0;
char	loadfile[SETUP_FILE_LEN];
struct itimerval	timer;

void console_event_proc ();
void menu_proc_setup ();
void menu_proc_quit ();
void menu_proc_spy (Menu menu, Menu_item menu_item);
void menu_proc_pause ();
void menu_proc_about ();
void menu_proc_help ();
void menu_proc_default ();
void menu_proc_special ();
void menu_proc_proclist ();
void menu_proc_tracelist ();
void open_lkdfile ();
void test_proc ();
void menu_proc_reset ();
void usage_proc ();
Notify_value reset_timer_func ();

extern char *optarg;

main(int argc, char *argv[])
	{
	char 	buf[100];
	char	c;
	int errflg=0;
	Cms cms;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, XV_USAGE_PROC, usage_proc, NULL);

	load_setup_data ();
	strcpy (loadfile, setupdata.loadfile);

	while ((c=getopt (argc, argv, "nl:f:"))!=-1)
		switch (c)
			{
			case 'n':
				noreset=1;
				break;
			case 'l':
				strncpy (setupdata.linkdriver, optarg, SETUP_FILE_LEN);
				break;
			case 'f':
				strncpy (loadfile, optarg, SETUP_FILE_LEN);
				break;
			case '?':
			default:
				errflg++;
			}
	if (errflg)
		usage_proc ();

/* Create the console window, initialize menus etc. */

	console.frame = xv_create(XV_NULL, FRAME,
		FRAME_LABEL,		"XWIO console",
		NULL);

	console.panel = (Panel) xv_create (console.frame, PANEL, NULL);

	menu1 = (Menu) xv_create (NULL, MENU, 
		MENU_ITEM,
			MENU_STRING,		"Open...",
			MENU_NOTIFY_PROC,	open_lkdfile,
			NULL,
		MENU_ITEM,
			MENU_STRING,		"Reset",
			MENU_NOTIFY_PROC,	menu_proc_reset,
			NULL,
		MENU_ITEM,	
			MENU_STRING,		"Setup...",
			MENU_NOTIFY_PROC,	menu_proc_setup,
			NULL,
		MENU_ITEM,
			MENU_STRING,		"Quit",
			MENU_NOTIFY_PROC,	menu_proc_quit,
			NULL,
		NULL);

	xv_create (console.panel, PANEL_BUTTON, 
		PANEL_LABEL_STRING,	"System",
		PANEL_ITEM_MENU,	menu1,
		NULL);

	menu2 = (Menu) xv_create (NULL, MENU,
		MENU_ITEM,
			MENU_STRING,		"Spy",
			MENU_NOTIFY_PROC,	menu_proc_spy,
			NULL,
		MENU_ITEM,
			MENU_STRING,		"Process list...",
			MENU_NOTIFY_PROC,	menu_proc_proclist,
			NULL,
		MENU_ITEM,
			MENU_STRING,		"Trace...",
			MENU_NOTIFY_PROC,	menu_proc_tracelist,
			NULL,
		MENU_ITEM,
			MENU_STRING,		"Pause",
			MENU_NOTIFY_PROC,	menu_proc_pause,
			NULL,
		NULL);

	xv_create (console.panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Debug",
		PANEL_ITEM_MENU,	menu2,
		NULL);

	menu3 = (Menu) xv_create (NULL, MENU,
		MENU_ITEM,
			MENU_STRING,		"Index...",
			MENU_NOTIFY_PROC,	menu_proc_help,
			NULL,
		MENU_ITEM,
			MENU_STRING,		"About...",
			MENU_NOTIFY_PROC,	menu_proc_about,
			NULL,
		NULL);
		
	xv_create (console.panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,	"Help",
		PANEL_ITEM_MENU,	menu3,
		NULL);

	console.message = xv_create (console.panel, PANEL_MESSAGE,
		PANEL_LABEL_STRING,	"...",
		NULL);

	window_fit_height(console.panel); 

/*	console subwindow as tty , removed for X11R6
 *	console.tty=(Tty) xv_create (console.frame, TTY,
 *		TTY_ARGV,		TTY_ARGV_DO_NOT_FORK,
 *		WIN_BELOW,		console.panel,  
 *		WIN_X,         		 0,
 *		NULL);
 */

/*
 *	do PROLOG system initialization and create hooks to X.
 */

	console.link=NULL;
	console.openchooser = NULL;
	console.dpy=(Display *)xv_get (console.frame, XV_DISPLAY);
	console.screen_no=(int) xv_get ((Xv_screen)xv_get (console.frame, XV_SCREEN), SCREEN_NUMBER);

	gc=XCreateGC (console.dpy, RootWindow (console.dpy, console.screen_no), 0, NULL);
	/*
	XSetForeground (console.dpy, gc, BlackPixel (console.dpy, console.screen_no));
	XSetBackground (console.dpy, gc, WhitePixel (console.dpy, console.screen_no));
	*/

	cms = (Cms) xv_get (console.frame, WIN_CMS);
	XSetForeground (console.dpy, gc, xv_get (cms, CMS_FOREGROUND_PIXEL));
	XSetBackground (console.dpy, gc, xv_get (cms, CMS_BACKGROUND_PIXEL));

	font=XQueryFont (console.dpy, (GContext)XGContextFromGC (gc));

	console.twin = (struct TwinStruct *)malloc (sizeof (struct TwinStruct));
	make_twin_sub (console.frame, 25, 80, console.twin);
	xv_set (console.twin->canvas, WIN_BELOW, console.panel, NULL);
	
	xv_set (console.frame, XV_WIDTH, xv_get (console.twin->canvas, XV_WIDTH), NULL);
	window_fit(console.frame);

/*	xv_set (console.frame, 
		WIN_EVENT_PROC,		console_event_proc,
		WIN_CONSUME_EVENTS,	WIN_STRUCTURE_NOTIFY, NULL,
		NULL);
 */

	twin_menu= (Menu) xv_create (NULL, MENU,
		MENU_ITEM, 
			MENU_STRING, 		"Pause",
			MENU_NOTIFY_PROC,	menu_proc_pause,
			NULL,
		MENU_ITEM,
			MENU_STRING,		"Font...",
			MENU_NOTIFY_PROC,	menu_proc_default,
			NULL,
		NULL);

	proc_list=init_list ();
	object_plist= plist_init ();

	if (setupdata.spyonbootflag)
		InitMsgSpy (setupdata.spyfile);

	trace_list=init_list ();
	dummyframe=(Frame) xv_create (NULL, FRAME, NULL);
	dummy_twin=(struct TwinStruct *)malloc (sizeof (struct TwinStruct));
	make_twin_sub (dummyframe, T_DISPLAY_Y, T_DISPLAY_X, dummy_twin);
	fRunAll=0;

/*
 *	set stdin/out to console.tty pipes...
 *	init curses package for tty.
 */

/*	works only with console tty...
 *	dup2 ((int)xv_get (console.tty, TTY_TTY_FD), 0);
 *	dup2 ((int)xv_get (console.tty, TTY_TTY_FD), 1);
 *
 *
 *	initscr();
 */


	if (!noreset)
		{
		timer.it_value.tv_usec=0;
		timer.it_value.tv_sec=1;
		timer.it_interval.tv_usec=0;
		timer.it_interval.tv_sec=0;
		notify_set_itimer_func (177, reset_timer_func, ITIMER_REAL, &timer, NULL);
		}

	xv_main_loop(console.frame);

	printf ("main_loop returned. XWIO done.\n");
	}

void cleanup ()
	{
	int	pid;

	pid=0;
	while (pid=plist_next (object_plist,pid))
		destroy_object (pid);
	TraceClear ();
	ClearProcess ();
	if (console.link)
		(console.link)->fPause=0;
	}

void quit ()
	{
	CloseMsgSpy ();
	if (console.link)
		KillLink (console.link);
	xv_destroy (menu1);
	xv_destroy (menu2);
	xv_destroy (menu3);
	xv_destroy (twin_menu);
	destroy_twin_sub (dummy_twin);
	xv_destroy (dummyframe);
	cleanup ();
	xv_destroy_safe (console.frame);
	exit (0);
	}

extern int out_fd;
extern int out_client;

void menu_proc_special (menu, menu_item)
	Menu menu;
	Menu_item	menu_item;
	{
	out_proc (out_client, out_fd);
	}

void menu_proc_default (menu, menu_item)
	Menu menu;
	Menu_item	menu_item;
	{
	/*printf ("proc_default: %s not implementd...\n",xv_get (menu_item, MENU_STRING));*/
	}

void menu_proc_setup (Menu menu, Menu_item menu_item)
	{
	setup_dlg ();
	}

void menu_proc_pause (Menu menu, Menu_item menu_item)
	{
	pause_link (console.link);
	}

void menu_proc_proclist (Menu menu, Menu_item menu_item)
	{
	process_list (console.frame, 0);
	}

void menu_proc_spy (Menu menu, Menu_item menu_item)
	{
	if (spy)
		CloseMsgSpy ();
	else
		InitMsgSpy (0);
	}

void menu_proc_tracelist (Menu menu, Menu_item menu_item)
	{
	trace_window (console.frame);
	}

void test_proc (Menu menu, Menu_item menu_item)
	{
	}

void menu_proc_reset (Menu menu, Menu_item menu_item)
	{
	Xv_notice	notice;
	int		notice_stat;

	if (console.link==NULL)
		{
		if (!(console.link=InitMyLink (setupdata.linkdriver)))
			{
			simple_write (console.twin, "InitMyLink failed for linkdriver ");
			simple_write (console.twin, setupdata.linkdriver);
			simple_write (console.twin, " \n");
			return;
			}
		}
	else 	{
		notice= xv_create (console.frame, NOTICE,
			NOTICE_MESSAGE_STRING,	"PROLOG: \nReset System ?",
			NOTICE_BUTTON_YES,	"Yes",
			NOTICE_BUTTON_NO,	"No",
			NOTICE_STATUS,		&notice_stat,
			XV_SHOW,		TRUE,
			NULL);
		xv_destroy_safe (notice);

		if (notice_stat == NOTICE_YES)
			{
			cleanup ();
			KillLink (console.link);
			}
		else
			return;
		}
	if (-1==Reset (console.link))
		{
		simple_write (console.twin, "XWIO: Reset failed.\n");
		return;
		}
	StartLinkLoops (console.link);
	}

void menu_proc_about (Menu menu, Menu_item menu_item)
	{
	Xv_notice	notice;
	
	notice= xv_create (console.frame, NOTICE,
		NOTICE_MESSAGE_STRING,	"XWIO V1.10\nTransputer host server\nBrain Aid Systems 1993,94,95\nFrank Bergmann\nMartin Ostermann\nGuido von Walter",
		NOTICE_BUTTON_YES,	"Ok",
		XV_SHOW,		TRUE,
		NULL);
	xv_destroy_safe (notice);
	}

Notify_value system_sigchldcatcher (Notify_client client, int pid, union wait *status, struct rusage *rusage)
        {
        if (WIFEXITED (*status))
                return NOTIFY_DONE;
        return NOTIFY_IGNORED;
        }

void menu_proc_help (Menu menu, Menu_item menu_item)
	{
	int	pid;
	switch (pid = fork ())
		{
		case -1:
			return;
		case 0:
			system (setupdata.helpviewer);
			_exit(0);
		default:
			notify_set_wait3_func (SYSTEM_ID, system_sigchldcatcher, pid);
			return;
		}
	}

void menu_proc_quit (Menu menu, Menu_item menu_item)
	{
	Xv_notice	notice;
	int		notice_stat;

	notice= xv_create (console.frame, NOTICE,
		NOTICE_MESSAGE_STRING,	"Quit PROLOG system ?",
		NOTICE_BUTTON_YES,	"Yes",
		NOTICE_BUTTON_NO,	"No",
		NOTICE_STATUS,		&notice_stat,
		XV_SHOW,		TRUE,
		NULL);
	xv_destroy_safe (notice);

	if (notice_stat == NOTICE_YES)
		{
		simple_write (console.twin, " quit received...\n");
		quit ();
		}
	}

void console_event_proc (Xv_Window window, Event *event, Notify_arg arg)
	{
	char buf[100];
	
	switch (event_action (event))
		{
		case WIN_RESIZE:
/*			refresh ();*/
			break;
		}
	return ;
	}

void usage_proc (char *name)
	{
	printf ("XWIO Brain Aid X11 Host Server v0.95\n");
	printf ("xwio [-n] [-f loadfile] [-l linkdriver]\n");
	xv_usage (name);
	exit(1);
	}

Notify_value reset_timer_func (Notify_client client, int which)
/*
 *	startup timer...
 */
	{
	notify_set_itimer_func (console.frame, NOTIFY_FUNC_NULL, ITIMER_REAL, NULL, NULL);
	menu_proc_reset ((Menu)0, (Menu_item)0);
	return NOTIFY_DONE;
	}

#ifdef USE_FILECHOOSER
open_chooser_notify_func (File_chooser fc, char *path, char *file, Xv_opaque client_data)
/*
 *	File Chooser callback function
 */
	{
	RunApp (path);
	xv_destroy_safe (console.openchooser);
	console.openchooser = NULL;
	}
#endif

void open_lkdfile (Panel_item item, Event *event)
/*	
 *	Callback for open menu item in console window
 */
	{
#ifdef USE_FILECHOOSER
	if (console.openchooser != NULL)
		return;
	console.openchooser = xv_create (console.frame, FILE_CHOOSER_OPEN_DIALOG,
		XV_LABEL,	"Xwio: Open",
		FILE_CHOOSER_NOTIFY_FUNC,	open_chooser_notify_func,
		XV_SHOW,	TRUE,
		NULL);
#else
	open_lkd_dlg (console.frame);
#endif
	}
		
char *strlwr (char *str)
	{
	char *i=str;
	while (*i)
		{
		*i=tolower (*i);
		i++;
		}
	return str;
	}

void ERROR (char *str)
/*	
 *	print error msg to console window.
 */

	{
	simple_write (console.twin, "ERROR: ");
	simple_write (console.twin, str);
	simple_write (console.twin, "\n");
	}

void error_box (char *str)
/*
 *	notice (mesagebox) for PROLOG error conditions.
 */

	{
	Xv_notice	notice;

	notice= xv_create (console.frame, NOTICE,
		NOTICE_MESSAGE_STRING,	str,
		XV_SHOW,		TRUE,
		NULL);
	xv_destroy_safe (notice);
	}

char *binfile (char *file)
        {
        static char str[100];
        strcpy (str, getenv ("BBIN"));
        strcat (str, file);
        return str;
        }

char *nextpath (char *path, char *str)
	{
	int	i=0;
	if (path[i]=='\0')
		return NULL;
	while (path[i]!='\0' && path[i]!=':')
		i++;
	strncpy (str, path, i);
	if (str[i-1] != '/') {
		str[i] = '/';
		str[i+1]=0;
		}
	else
		str[i]=0;
	if (path[i]==':')
		i++;
	return path+i;
	}

char *find_file (char *file)
	{
	static char str[300];
	char *p;
	struct stat status;

	strcpy (str, file);
	if (strrchr (file, '\n'))
		*(strrchr (file, '\n'))='\0';
	p=getenv ("BBIN");
	while (-1==stat (str, &status))
		{
		p=nextpath (p, str);
		if (!p) {
			fprintf (stderr, "couldn't open file %s.\n", file);
			return NULL;
			}
		strcat (str, file);
		}
	return str;
	}

char *basename (char *str)
	{
	char *s;
	if (!(s=strrchr (str, '/')))
		return str;
	else
		return s+1;
	}

int host_exec (char *str)
/*
 *	execute program on host system...
 */
	{
	int pid;
	char *shell;

	shell=getenv ("SHELL");
	if (!shell)
		shell="/bin/sh";
	switch (pid=fork ())
		{
		case 0:
			execl (shell,basename (shell),"-c",str,NULL);
			perror ("hostexec:");
			_exit (0);
		default:
			return pid;
		}
	}

