/*
 *	Setup.c	
 *	Setup dialog functions...
 */

#include "xwio.h"
#include <stdlib.h>
#include <stdio.h>

extern struct ConsoleStruct console;

struct SetupDataStruct setupdata;

struct SetupStruct setup;

#ifdef USE_FILECHOOSER
int open_callback (File_chooser fc, char *path, char *file, Xv_opaque client_data);
#endif


int getkey (char *str, char **key, char **cont)
/*
 *	extract key and contents from deafult entry
 */
	{
	char	*p;
	p=str;
	while (isspace (*p))
		p++;
	if (*p=='#')
		return 0;
	else	{
		*key=p;
		p=strchr (p, ':');
		if (!p)
			return 0;
		*p='\0';
		strlwr (*key);
		*cont=++p;
		}
	return 1;
	}

char *whatkey (char *str)
/*
 *	extract key without changing str.
 */
	{
	char	*p, *a;
	char 	key[300];
	strcpy (key, str);
	p=key;
	while (isspace (*p))
		p++;
	if (*p=='#')
		return 0;
	else	{
		a=p;
		p=strchr (p, ':');
		if (!p)
			return 0;
		*p='\0';
		strlwr (a);
		}
	return a;
	}

void load_setup_data ()
/*
 *	load the defaults from .wiorc
 */
	{
	FILE	*f;
	char	str[300];
	char	*key, *cont;

		strcpy (setupdata.linkdriver, "bbk-s4 b0 l0");
		strcpy (setupdata.loadfile, "shell.lkd");
		strcpy (setupdata.networkfile, "generic.boo");
		strcpy (setupdata.helpviewer, "lynx file://$BBIN/bap.html");

	strcpy (str, getenv ("HOME"));
	strcat (str, "/.xwiorc");
	
	f=fopen (str, "r");
	if (f)	{
		while (!feof(f))
			{
			fgets (str, 300, f);
			if (getkey (str, &key, &cont))
				{
				if (!strcmp (key, "link"))
					strncpy (setupdata.linkdriver, cont, SETUP_FILE_LEN);
				if (! strcmp (key, "load"))
					strncpy (setupdata.loadfile, cont, SETUP_FILE_LEN);
				if (! strcmp (key, "netfile"))
					strncpy (setupdata.networkfile, cont, SETUP_FILE_LEN);
				if (! strcmp (key, "helpviewer"))
					strncpy (setupdata.helpviewer, cont, 255);
				}
			}
		fclose (f);
		}
	}

void save_setup_data ()
/*
 *	save the current settings as defaults
 */
	{
	FILE	*f, *f2;
	char	str2[300];
	char	str[300];
	char	s[300];
	char	*t;
	int	link_done =0, load_done=0, netfile_done =0, helpviewer_done=0;

	strcpy (str, getenv ("HOME"));
	strcpy (str2, str);
	strcat (str, "/.xwiorc");
	strcat (str2, "/.xwiotmp");
	
	f=fopen (str, "r");
	f2=fopen (str2, "w");
	if (f && f2)
		{
		while (!feof(f))
			{
			fgets (s, 300, f);
			if (!feof(f)) {
				if (t=whatkey (s))
					{
					if (!strcmp (t, "link"))
						{
						if (strrchr (setupdata.linkdriver, '\n'))
							*(strrchr (setupdata.linkdriver, '\n'))='\0';
						fprintf (f2, "link:%s\n",setupdata.linkdriver);
						link_done =1;
						}
					else
						{
						if (!strcmp (t, "load"))
							{
							if (strrchr (setupdata.loadfile, '\n'))
								*(strrchr (setupdata.loadfile, '\n'))='\0';
							fprintf (f2, "load:%s\n",setupdata.loadfile);
							load_done =1;
							}
						else
							{
							if (!strcmp (t, "netfile"))
								{
								if (strrchr (setupdata.networkfile, '\n'))
									*(strrchr (setupdata.networkfile, '\n'))='\0';
								fprintf (f2, "netfile:%s\n",setupdata.networkfile);
								netfile_done =1;
								}
							else
								{
								if (!strcmp (t, "helpviewer"))
									{
									if (strrchr (setupdata.helpviewer, '\n'))
										*(strrchr (setupdata.helpviewer, '\n'))='\0';
									fprintf (f2, "helpviewer:%s\n",setupdata.helpviewer);
									helpviewer_done =1;
									}
								else
									fprintf (f2, "%s", s);
								}
							}
						}
					}
				else
					fprintf (f2, "%s", s);
				}

			}
		if (!link_done) {
			if (strrchr (setupdata.linkdriver, '\n'))
				*(strrchr (setupdata.linkdriver, '\n'))='\0';
			fprintf (f2, "link:%s\n",setupdata.linkdriver);
			}
		if (!load_done) {
			if (strrchr (setupdata.loadfile, '\n'))
				*(strrchr (setupdata.loadfile, '\n'))='\0';
			fprintf (f2, "load:%s\n",setupdata.loadfile);
			}
		if (!netfile_done) {
			if (strrchr (setupdata.networkfile, '\n'))
				*(strrchr (setupdata.networkfile, '\n'))='\0';
			fprintf (f2, "netfile:%s\n",setupdata.networkfile);
			}
		if (!helpviewer_done) {
			if (strrchr (setupdata.helpviewer, '\n'))
				*(strrchr (setupdata.helpviewer, '\n'))='\0';
			fprintf (f2, "helpviewer:%s\n",setupdata.helpviewer);
			}
		fclose (f);
		fclose (f2);
		unlink (str);
		rename (str2, str);
		}
	}

/*
 *	notify functions for setup panel:
 */

void generic_networkfile (Panel_item item, Event *event)
	{
	strcpy (setupdata.networkfile, "generic.boo");
	xv_set (setup.networkfile, PANEL_VALUE, setupdata.networkfile,NULL);
	}

void gcel_networkfile (Panel_item item, Event *event)
	{
	strcpy (setupdata.networkfile, "gcel.boo");
	xv_set (setup.networkfile, PANEL_VALUE, setupdata.networkfile,NULL);
	}

void select_networkfile (Panel_item item, Event *event)
	{
#ifdef USE_FILECHOOSER
	if (!setup.network_chsr)
		setup.network_chsr= (File_chooser) xv_create (setup.frame, FILE_CHOOSER_OPEN_DIALOG,
			XV_LABEL,		"Setup: Network File",
			FILE_CHOOSER_NOTIFY_FUNC,	open_callback,
			XV_KEY_DATA,		CHSR_KEY,	KEY_SETUP_NETWORK,
			NULL);

	xv_set (setup.network_chsr, XV_SHOW, TRUE, NULL);
#endif
	}

void select_loadfile (Panel_item item, Event *event)
	{
#ifdef USE_FILECHOOSER
	if (!setup.loadfile_chsr)
		setup.loadfile_chsr= (File_chooser) xv_create (setup.frame, FILE_CHOOSER_OPEN_DIALOG,
			XV_LABEL,		"Setup: Load File",
			FILE_CHOOSER_NOTIFY_FUNC,	open_callback,
			XV_KEY_DATA,		CHSR_KEY,	KEY_SETUP_LOADFILE,
			NULL);

	xv_set (setup.loadfile_chsr, XV_SHOW, TRUE, NULL);
#endif
	}

void setup_default (Panel_item item, Event *event)
	{
	strcpy (setupdata.networkfile, "single.boo");
	xv_set (setup.networkfile, PANEL_VALUE, setupdata.networkfile,NULL);
	strcpy (setupdata.loadfile, "shell.lkd");
	xv_set (setup.loadfile, PANEL_VALUE, setupdata.loadfile,NULL);
	strcpy (setupdata.linkdriver, "BBK S4 B0 L0");
	xv_set (setup.linkdriver, PANEL_VALUE, setupdata.linkdriver,NULL);
	strcpy (setupdata.helpviewer, "lynx file://$BBIN/bap.html");
	xv_set (setup.helpviewer, PANEL_VALUE, setupdata.helpviewer,NULL);
	}

void setup_cancel (Panel_item item, Event *event)
	{
	setupdata= setup.oldsetup;
	xv_destroy_safe (setup.frame);
	setup.frame=0;
	}

void setup_use (Panel_item item, Event *event)
	{
	strncpy (setupdata.networkfile, xv_get (setup.networkfile, PANEL_VALUE), SETUP_FILE_LEN);
	strncpy (setupdata.loadfile, xv_get (setup.loadfile, PANEL_VALUE), SETUP_FILE_LEN);
	strncpy (setupdata.linkdriver, xv_get (setup.linkdriver, PANEL_VALUE), SETUP_FILE_LEN);
	strncpy (setupdata.helpviewer, xv_get (setup.helpviewer, PANEL_VALUE), SETUP_FILE_LEN);
	xv_destroy_safe (setup.frame);
	setup.frame=0;
	}

void setup_save (Panel_item item, Event *event)
	{
	setup_use (item, event);
	save_setup_data ();
	}

#ifdef USE_FILECHOOSER
int open_callback (File_chooser fc, char *path, char *file, Xv_opaque client_data)
	{
	int key=xv_get (fc, XV_KEY_DATA, CHSR_KEY);
	switch (key)
		{
		case KEY_SETUP_NETWORK:
			xv_set (setup.networkfile, PANEL_VALUE, path, NULL);
			break;
		case KEY_SETUP_LOADFILE:
			xv_set (setup.loadfile, PANEL_VALUE, path, NULL);
			break;
		/*
		case KEY_CONSOLE_OPEN:
			prolog_run (path, file);
			break;
		*/
		}
	return XV_OK;
	}
#endif

void setup_dlg ()
	{
	Panel panel;

	if (!setup.frame)
		{
		setup.oldsetup=setupdata;

		setup.frame= (Frame)xv_create (console.frame, FRAME,
			FRAME_LABEL,		"Setup",
			XV_WIDTH,		400,
			XV_HEIGHT,		200,
			NULL);
	
		panel= (Panel) xv_create (setup.frame, PANEL, NULL);
		setup.linkdriver= xv_create (panel, PANEL_TEXT,
			PANEL_LAYOUT,		PANEL_HORIZONTAL,
			PANEL_LABEL_STRING,	"Link Device: ",
			PANEL_VALUE,		setupdata.linkdriver,
			NULL);
		setup.networkfile= xv_create (panel, PANEL_TEXT,
			PANEL_LABEL_STRING,	"Network file:",
			PANEL_VALUE,		setupdata.networkfile,
			NULL);
		xv_create (panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Select...",
			PANEL_NOTIFY_PROC,	select_networkfile,
			NULL);
		xv_create (panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Generic",
			PANEL_NOTIFY_PROC,	generic_networkfile,
			NULL);
		xv_create (panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"GCel",
			PANEL_NOTIFY_PROC,	gcel_networkfile,
			NULL);

		setup.loadfile= xv_create (panel, PANEL_TEXT,
			PANEL_NEXT_ROW, 	-1,
			PANEL_LABEL_STRING,	"Default loadfile:",
			PANEL_VALUE,		setupdata.loadfile,
			NULL);
		xv_create (panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Select...",
			PANEL_NOTIFY_PROC,	select_loadfile,
			NULL);
		setup.helpviewer= xv_create (panel, PANEL_TEXT,
			PANEL_NEXT_ROW, 	-1,
			PANEL_LABEL_STRING,	"Help viewer:",
			PANEL_VALUE,		setupdata.helpviewer,
			NULL);
		xv_create (panel, PANEL_BUTTON,
			PANEL_NEXT_ROW,		-1,
			PANEL_LABEL_STRING,	"Default",
			PANEL_NOTIFY_PROC,	setup_default,
			NULL);
		xv_create (panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Save",
			PANEL_NOTIFY_PROC,	setup_save,
			NULL);
		xv_create (panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Use",
			PANEL_NOTIFY_PROC,	setup_use,
			NULL);
		xv_create (panel, PANEL_BUTTON,
			PANEL_LABEL_STRING,	"Cancel",
			PANEL_NOTIFY_PROC,	setup_cancel,
			NULL);
		xv_set (setup.frame, XV_SHOW, TRUE, NULL);
		}
	else
		{
		xv_destroy_safe (setup.frame);
		setup.frame=0;
		}
	}

