#include "xwio.h"
#include <stdio.h>
#include <stdlib.h>

#define SPY_FILE_NAME	"spy.lst"
#define SPY_COLS	80
#define SPY_ROWS	100

extern struct SpyStruct *spy;
extern struct ConsoleStruct console;

void spy_proc_file (Panel_item item, int value, Event *event)
/*
 *	"File protocol" checkbox ntify proc.
 */
	{
	if (value)
		if (! spy->f)
			spy->f=fopen (SPY_FILE_NAME, "a");
	else
		if (spy->f)
			{
			fclose (spy->f);
			spy->f=0;
			}
	}

void spy_proc_clear (Panel_item item, Event *event)
/*
 *	"Clear" button notify proc.
 */
	{
	if (spy->f)
		{
		fclose (spy->f);
		spy->f=fopen (SPY_FILE_NAME, "w");
		}
#ifdef SPY_WINDOW
	simple_clear (spy->twin);
#endif
	}

void spy_proc_pause (Panel_item item, Event *event)
/*
 *	"Pause" button ntify proc.
 */
	{
	pause_link (console.link);
	}

void InitMsgSpy (int fileflag)
	{
	Panel	panel;

	spy=(struct SpyStruct *)malloc (sizeof (struct SpyStruct));
	if (NULL==spy)
		return;
	if (fileflag)
		spy->f= fopen (SPY_FILE_NAME, "a");
	else
		spy->f=NULL;
	spy->frame= (Frame) xv_create (NULL, FRAME, 
		WIN_COLUMNS,		SPY_COLS +1,
		FRAME_LABEL,		"Message Spy",
		NULL);
	panel= (Panel) xv_create (spy->frame, PANEL, NULL);
	xv_create (panel, PANEL_BUTTON,
		PANEL_LABEL_STRING, 		"Pause",
		PANEL_NOTIFY_PROC,		spy_proc_pause,
		NULL);
#ifdef SPY_WINDOW
	xv_create (panel, PANEL_BUTTON,
		PANEL_LABEL_STRING,		"Clear",
		PANEL_NOTIFY_PROC,		spy_proc_clear,
		NULL);
#endif
	xv_create (panel, PANEL_CHECK_BOX,
		PANEL_CHOICE_STRINGS,		"File protocol", NULL,
		PANEL_NOTIFY_PROC,		spy_proc_file,
		PANEL_VALUE,			(spy->f ? 1 : 0), 
		NULL);
	window_fit_height (panel);
#ifdef SPY_WINDOWS
	spy->twin=(struct TwinStruct *)malloc (sizeof (struct TwinStruct));
	make_twin_sub (spy->frame, SPY_ROWS, SPY_COLS, spy->twin);
	xv_set ((spy->twin)->canvas, WIN_BELOW,	panel, NULL);
#endif
	window_fit (spy->frame);
	xv_set (spy->frame,
#ifdef SPY_WINDOWS
		WIN_ROWS,		15,
#endif
		XV_SHOW,		TRUE,
		NULL);
	}

void CloseMsgSpy ()
	{
	if (NULL==spy)
		return;
	if (spy->f)
		fclose (spy->f);
#ifdef SPY_WINDOW
	destroy_twin_sub (spy->twin);
	free (spy->twin);
#endif
	xv_destroy_safe (spy->frame);
	free (spy);
	spy=NULL;
	}

void WriteMsgSpyIn (char *msg)
/* Show Message in Spy Window */
	{
	char	text[4000];

	if (! spy)
		return;
	sprintf (text, "in from %d/%d:",bufint16 (msg+4),bufint (msg));
#ifdef SPY_WINDOW
	simple_write (spy->twin, text);
#else
	fprintf (stderr, "%s", text);
#endif
	if (spy->f)
		fputs (text, spy->f);
	PrintMsg (text, msg+8);
	strcat (text, "\n");
#ifdef SPY_WINDOW
	simple_write (spy->twin, text);
#else
	fprintf (stderr, "%s", text);
#endif
	if (spy->f)
		fputs (text, spy->f);
	}

void WriteMsgSpyOut (char *Header, char *msg)
/* Show Message in Spy Window */
	{
	char			text[4000];

	if (!spy)
		return;
	sprintf (text, "out to  %d/%d:", bufint16 (Header+4), bufint (Header));
#ifdef SPY_WINDOW
	simple_write (spy->twin, text);
#else
	fprintf (stderr, "%s", text);
#endif
	if (spy->f)
		fputs (text, spy->f);
	PrintMsg (text, msg);
	strcat (text, "\n");
#ifdef SPY_WINDOW
	simple_write (spy->twin, text);
#else
	fprintf (stderr, "%s", text);
#endif
	if (spy->f)
		fputs (text, spy->f);
	}
